/*      COMMDLG.H -- RJG's attempt to make COMMDLG.DLL usefull. */

#if !defined(_COMMDLG_H)
#define _COMMDLG_H

#ifndef __WINDOWS_H
#undef NULL
#include <windows.h>
#endif

#if !defined( __DRIVINIT_H )
#include    <drivinit.h>
#endif


typedef struct {   /* cc */
    DWORD   lStructSize;
    HWND    hwndOwner;
    HANDLE  hInstance;
    DWORD   rgbResult;
    LPDWORD lpCustColors;
    DWORD   Flags;
    DWORD   lCustData;
    FARPROC lpfnHook;
    LPSTR   lpTemplateName;
} CHOOSECOLOR;
typedef CHOOSECOLOR      *PCHOOSECOLOR;
typedef CHOOSECOLOR NEAR *NPCHOOSECOLOR;
typedef CHOOSECOLOR FAR  *LPCHOOSECOLOR;


/* This is the 32 bit version of LOGFONT */
typedef struct tagLOGFONT32 {    /* lf */
   LONG lfHeight;
   LONG lfWidth;
   LONG lfEscapement;
   LONG lfOrientation;
   LONG lfWeight;
   BYTE  lfItalic;
   BYTE  lfUnderline;
   BYTE  lfStrikeOut;
   BYTE  lfCharSet;
   BYTE  lfOutPrecision;
   BYTE  lfClipPrecision;
   BYTE  lfQuality;
   BYTE  lfPitchAndFamily;
   BYTE  lfFaceName[LF_FACESIZE];
} LOGFONT32;
typedef LOGFONT32        *PLOGFONT32;
typedef LOGFONT32 NEAR   *NPLOGFONT32;
typedef LOGFONT32 FAR    *LPLOGFONT32;


typedef struct {    /* cf */
    DWORD     lStructSize;
    HWND      hwndOwner;
    HDC       hDC;
#ifdef _LF32
    LPLOGFONT32 lpLogFont;  /* Changed type to 32 bit version */
#else
    LPLOGFONT lpLogFont;
#endif
    int       iPointSize;
    DWORD     Flags;
    DWORD     rgbColors;
    DWORD     lCustData;
    FARPROC   lpfnHook;
    LPSTR     lpTemplateName;
    HANDLE    hInstance;
    LPSTR     lpszStyle;
    WORD      nFontType;
    int       nSizeMin;
    int       nSizeMax;
} CHOOSEFONT;
typedef CHOOSEFONT      *PCHOOSEFONT;
typedef CHOOSEFONT NEAR *NPCHOOSEFONT;
typedef CHOOSEFONT FAR  *LPCHOOSEFONT;


typedef struct {    /* fr */
    DWORD   lStructSize;
    HWND    hwndOwner;
    HANDLE  hInstance;
    DWORD   Flags;
    LPSTR   lpstrFindWhat;
    LPSTR   lpstrReplaceWith;
    WORD    wFindWhatLen;
    WORD    wReplaceWithLen;
    DWORD   lCustData;
    FARPROC lpfnHook;
    LPSTR   lpTemplateName;
} FINDREPLACE;
typedef FINDREPLACE      *PFINDREPLACE;
typedef FINDREPLACE NEAR *NPFINDREPLACE;
typedef FINDREPLACE FAR  *LPFINDREPLACE;


typedef struct tagOFN { /* ofn */
    DWORD   lStructSize;
    HWND    hwndOwner;
    HANDLE  hInstance;
    LPSTR   lpstrFilter;
    LPSTR   lpstrCustomFilter;
    DWORD   nMaxCustFilter;
    DWORD   nFilterIndex;
    LPSTR   lpstrFile;
    DWORD   nMaxFile;
    LPSTR   lpstrFileTitle;
    DWORD   nMaxFileTitle;
    LPSTR   lpstrInitialDir;
    LPSTR   lpstrTitle;
    DWORD   Flags;
    WORD    nFileOffset;
    WORD    nFileExtension;
    LPSTR   lpstrDefExt;
    DWORD   lCustData;
    FARPROC lpfnHook;
    LPSTR   lpTemplateName;
} OPENFILENAME;
typedef OPENFILENAME      *POPENFILENAME;
typedef OPENFILENAME NEAR *NPOPENFILENAME;
typedef OPENFILENAME FAR  *LPOPENFILENAME;


typedef struct tagPD {  /* pd */
    DWORD   lStructSize;
    HWND    hwndOwner;
    HANDLE  hDevMode;
    HANDLE  hDevNames;
    HDC     hDC;
    DWORD   Flags;
    WORD    nFromPage;
    WORD    nToPage;
    WORD    nMinPage;
    WORD    nMaxPage;
    WORD    nCopies;
    HANDLE  hInstance;
    DWORD   lCustData;
    FARPROC lpfnPrintHook;
    FARPROC lpfnSetupHook;
    LPSTR   lpPrintTemplateName;
    LPSTR   lpSetupTemplateName;
    HANDLE  hPrintTemplate;
    HANDLE  hSetupTemplate;
} PRINTDLG;
typedef PRINTDLG      *PPRINTDLG;
typedef PRINTDLG NEAR *NPPRINTDLG;
typedef PRINTDLG FAR  *LPPRINTDLG;


typedef struct tagDEVNAMES {
    WORD wDriverOffset;
    WORD wDeviceOffset;
    WORD wOutputOffset;
    WORD wDefault;
    /* driver, device, and port-name strings follow wDefault */
} DEVNAMES;
typedef DEVNAMES      *PDEVNAMES;
typedef DEVNAMES NEAR *NPDEVNAMES;
typedef DEVNAMES FAR  *LPDEVNAMES;

/* CommDlgExtendedError returns */
#define CDERR_FINDRESFAILURE
#define CDERR_INITIALIZATION
#define CDERR_LOCKRESFAILURE
#define CDERR_LOADRESFAILURE
#define CDERR_LOADSTRFAILURE
#define CDERR_MEMALLOCFAILURE
#define CDERR_MEMLOCKFAILURE
#define CDERR_NOHINSTANCE
#define CDERR_NOHOOK
#define CDERR_NOTEMPLATE
#define CDERR_STRUCTSIZE
#define PDERR_CREATEICFAILURE
#define PDERR_DNDMMISMATCH
#define PDERR_GETDEVMODEFAIL
#define PDERR_INITFAILURE
#define PDERR_LOADDRVFAILURE
#define PDERR_NODEFAULTPRN
#define PDERR_NODEVICES
#define PDERR_PARSEFAILURE
#define PDERR_RETDEFFAILURE 4099
#define PDERR_SETUPFAILURE
#define CFERR_NOFONTS

/* CHOOSECOLOR.Flags */
#define CC_ENABLEHOOK
#define CC_ENABLETEMPLATE
#define CC_ENABLETEMPLATEHANDLE
#define CC_FULLOPEN
#define CC_PREVENTFULLOPEN
#define CC_RGBINIT
#define CC_SHOWHELP

/* CHOOSEFONT.Flags */
#define CF_APPLY                        0x00000200
#define CF_ANSIONLY                     0x00000400
#define CF_BOTH                         0x00000003  // ?
#define CF_TTONLY                       0x00000008  // ?
#define CF_EFFECTS                      0x00000100  // ?
#define CF_ENABLEHOOK
#define CF_ENABLETEMPLATE
#define CF_ENABLETEMPLATEHANDLE
#define CF_FIXEDPITCHONLY               0x00004000  // ?
#define CF_FORCEFONTEXIST
#define CF_INITTOLOGFONTSTRUCT          0x00000040
#define CF_LIMITSIZE                    0x00002000
#define CF_NOSIMULATIONS                0x00001000  //  ?
#define CF_NOVECTORFONTS                0x00000800
#define CF_PRINTERFONTS                 0x00000002  //  ?
#define CF_SCALABLEONLY                 0x00008000  //  ?
#define CF_SCREENFONTS                  0x00000001  //  ?
#define CF_SHOWHELP                     0x00000004  //  ?
#define CF_USESTYLE                     0x00010000  //  ?
#define CF_WYSIWYG                      0x00008000  // ?  dup?

/* CHOOSEFONT.nFontType */
#define SIMULATED_FONTTYPE
#define PRINTER_FONTTYPE
#define SCREEN_FONTTYPE

/* FINDREPLACE.Flags */
#define FR_DIALOGTERM
#define FR_DOWN
#define FR_ENABLEHOOK
#define FR_ENABLETEMPLATE
#define FR_ENABLETEMPLATEHANDLE
#define FR_FINDNEXT
#define FR_MATCHCASE
#define FR_NOMATCHCASE
#define FR_NOUPDOWN
#define FR_NOWHOLEWORD
#define FR_REPLACE
#define FR_REPLACEALL
#define FR_SHOWHELP
#define FR_WHOLEWORD

/* OPENFILENAME.Flags */
#define OFN_ALLOWMULTISELECT
#define OFN_CREATEPROMPT
#define OFN_FILEMUSTEXIST
#define OFN_ENABLEHOOK
#define OFN_ENABLETEMPLATE
#define OFN_ENABLETEMPLATEHANDLE
#define OFN_EXTENSIONDIFFERENT
#define OFN_FILEMUSTEXIST
#define OFN_HIDEREADONLY                0x00000004L
#define OFN_NOCHANGEDIR
#define OFN_OVERWRITEPROMPT             0x00000002L
#define OFN_PATHMUSTEXIST
#define OFN_READONLY                    0x00000001L
#define OFN_SHOWHELP                    0x00000010L

/* PRINTDLG.Flags */
#define PD_COLLATE                      0x00000010L
#define PD_ENABLEPRINTHOOK              0x00001000L // ?
#define PD_ENABLEPRINTTEMPLATE          0x00002000L // ?
#define PD_ENABLEPRINTTEMPLATEHANDLE    0x00004000L // ?
#define PD_ENABLESETUPHOOK              0x00008000L // ?
#define PD_ENABLESETUPTEMPLATE          0x00010000L // ?
#define PD_ENABLESETUPTEMPLATEHANDLE    0x00020000L // ?
#define PD_MODIFYDM
#define PD_NOPAGENUMS                   0x00000008L
#define PD_NOSELECTION                  0x00000004L
#define PD_PAGENUMS                     0x00000002L
#define PD_PRINTSETUP                   0x00000040L
#define PD_PRINTTOFILE                  0x00000020L
#define PD_RETURNDC                     0x00000100L // ?
#define PD_RETURNDEFAULT                0x00000400L
#define PD_RETURNIC                     0x00000200L // ?
#define PD_SELECTION                    0x00000001L
#define PD_SHOWHELP                     0x00000800L
#define PD_USEDEVMODECOPIES             0x00040000L


#ifdef __cplusplus
extern "C" {
#endif


DWORD FAR PASCAL CommDlgExtendedError(VOID);
BOOL  FAR PASCAL ChooseColor(LPCHOOSECOLOR);
BOOL  FAR PASCAL ChooseFont(LPCHOOSEFONT);
HWND  FAR PASCAL FindText(LPFINDREPLACE);
int   FAR PASCAL GetFileTitle(LPSTR lpszFile, LPSTR lpszTitle, LPSTR wBufSize);
BOOL  FAR PASCAL GetOpenFileName(LPOPENFILENAME);
BOOL  FAR PASCAL GetSaveFileName(LPOPENFILENAME);
BOOL  FAR PASCAL PrintDlg(LPPRINTDLG);
HWND  FAR PASCAL ReplaceText(LPFINDREPLACE);


#ifdef __cplusplus
}
#endif

#endif  /* _COMMDLG_H */
